/*
 * Copyright 2008 University of Chicago/Argonne National Laboratory
 *
 * @author Neill Miller
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "soapH.h"
#include "libglobus_adq.h"

//#define AUTH_SERVICE "http://localhost:8080/SamlAuthzProject/saml/soap/secure/authorizationService.htm"
//#define AUTH_SERVICE "https://esg.prototype.ucar.edu/saml/soap/secure/authorizationService.htm"
#define AUTH_SERVICE "https://esg.ucar.edu/saml/soap/secure/authorizationService.htm"

int main(int argc, char **argv)
{
    int ret = -1;
/*     char *openid = (char *)"https://esg.prototype.ucar.edu/myopenid/rootAdmin"; */
/*     char *resource = (char *)"http://tds.prototype.ucar.edu/thredds/fileServer/datazone/esg-cdp/xserve/ccsm/csm/b30.004/atm/proc/tseries/monthly/b30.004.cam2.h0.CLDHGH.0100-01_cat_0119-12.nc"; */
/*     char *openid = (char *)"Test Openid"; */
/*     char *resource = (char *)"/etc/group"; */
    char *openid = (char *)"https://esg.ucar.edu/myopenid/rootAdmin";
    char *resource = (char *)"gsiftp://vetsproc.ucar.edu:2811//datazone/narccap/data/CRCM/cgcm3-current/table1/sic_CRCM_1968010106.nc";
    authz_decision_t authz_out;
    memset(&authz_out, 0, sizeof(authz_out));

    ret = get_authorization_decision(
        (char *)AUTH_SERVICE, (char *)openid, (char *)resource,
        (char *)"read", &authz_out);

    if (ret == 0)
    {
        printf("Authz Decision returned successfully for Openid %s\n", openid);
        printf("Resource %s, Action %s, Decision %s\n", authz_out.resource, authz_out.action,
               ((authz_out.decision == ADQ_PERMIT) ? "Permit" : "Not Permitted"));
    }
    else
    {
        printf("Authz Decision Query failed for Openid %s\n", openid);
    }
    return 0;
} 
